<template>
  <div class="table">
    <div class="table_head">
      <div class="table-tr flex flex-middle">
        <div class="table-th">{{$t('history.winNum')}}</div>
        <div class="table-th">{{$t('history.all')}}</div>
        <div class="table-th">{{$t('history.wins')}}</div>
        <div class="table-th">{{$t('history.myWins')}}</div>
        <div class="table-th"><img
          src="~/static/icons/info.png"
          alt=""></div>
      </div>
    </div>
    <div class="table_body">
      <div
        class="table_body-inner"
        v-for="(item, key) in data"
        :class="'table_body-inner-'+ getClassType(item.stats)"
        :key="key">
        <div class="table-tr flex">
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
        </div>
        <div
          class="table-tr flex flex-middle lastWin"
          @click="showDetails(item)">
          <div class="table-td">
            <div class="lastWin-item_wrapper lastWin_number">
              <div class="betNumber">
                <div class="betNumber_inner">
                  {{item.win}}
                </div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_bet">
                <div class="color-white">
                  {{flooring(item.stats.total.wins.count + item.stats.total.losses.count)}}
                </div>
                <div>{{item.stats.total.bets_amount}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_amount">
                <div class="lastWin_color-winAmount">
                  {{item.stats.total.wins.count}}
                </div>
                <div>{{item.stats.total.wins.amount}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper">
              <div class="lastWin-item lastWin_myAmount">
                <div class="lastWin_color-myWinAmount">
                  {{(item.stats.player && item.stats.player.wins.count) || 0}}
                </div>
                <div>{{(item.stats.player && item.stats.player.wins.amount) || 0}} EOS</div>
              </div>
            </div>
          </div>
          <div class="table-td">
            <div class="lastWin-item_wrapper flex flex-middle flex-center">
              <Btn
                plain
                noPadding>
                <i class="i-icon-more i-deg90 color-icon"></i>
              </Btn>
            </div>
          </div>
        </div>
        <div class="table-tr flex">
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
          <div class="table-td"></div>
        </div>
      </div>
    </div>
    <div
      class="scroll_loader-overlay"
      v-show="loading">{{$t('common.refreshing')}}
    </div>
  </div>
</template>

<script>
  import Btn from '~/components/UI/Btn';
  import IconMenu from '~/components/UI/icons/icon-menu';
  import {flooring} from "../utils";

  export default {
    name: "History_body",
    props: {
      loading: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      data() {
        return this.$store.state.game.data.slice(0, 10);
      }
    },
    components: {
      Btn,
      IconMenu
    },
    methods: {
      flooring: flooring,
      getClassType(stats) {
        let type = '3';
        if (stats.total.losses.count && !stats.total.wins.count) type = '4';
        if (stats.player && stats.player.wins.count) type = '2';
        if (stats.player && !stats.player.wins.count && stats.player.losses.count && !this.$store.state.game.filters.wins) type = '1';
        if ((stats.player && !stats.player.wins.count && !stats.player.losses.count || !stats.player) && stats.total.wins.count) type = '0';
        if ((stats.player && !stats.player.wins.count && stats.player.losses.count || !stats.player) && stats.total.wins.count && this.$store.state.game.filters.wins) type = '0';
        /**
         * @deprecated
         */
        //if ((stats.player && stats.player.losses.count > 0) && stats.total.wins.count) type = '5';
        return type;
      },
      showDetails(item) {
        this.ga('bet', true);
        this.$store.commit('gameDetails/CLEAN_DETAILS');
        this.$nextTick(async _ => {
          const [err,res] = await (this.$store.dispatch("game/fetchGameInfo", item.house_seed_hash));
          if(!err && res) {
            item.compound_hash = res.compound_hash;
            item.house_seed = res.house_seed;
          }
          this.$store.commit('gameDetails/SET_HISTORY_GAME_SETTINGS', item);
          //TODO remove after backend refactor
          localStorage.getItem('accountname') && this.$store.dispatch('gameDetails/fetch', {
            hash: item.house_seed_hash,
            type: 'my'
          });
          this.$store.dispatch('gameDetails/fetch', {
            hash: item.house_seed_hash,
            type: 'others'
          });
          this.$store.commit('gameDetails/SET_SHOWING', true);
        });
      }
    }
  }
</script>
